<?php

namespace Bydedi\Mail;

use Swift_Attachment;
use Swift_Message;

class Message extends Swift_Message
{
    /**
     * @param $to
     * @param $subject
     * @param $body
     * @param null $from
     * @param array $files
     * @param string $layout
     *
     * @return Message
     */
    public static function create($to, $subject, $body, $from = null, $files = array(), $layout = 'bienvenue')
    {
        if (is_null($from)) {
            // TODO : default value
            // $from = array(Boutique::getInstance()->contactEmail => Boutique::getInstance()->nom);
        }

        if (!empty($layout)) {
            // TODO
            /*$smarty = new SiteSmarty();
            $smarty->assign('content_mail', $body);
            $body = $smarty->fetch('mail/'.$layout.'.tpl');*/
        }

        $message = new self($subject, $body);
        
        $message->setFrom($from)
            ->setTo($to)
            ->setContentType("text/html");

        if (!empty($files)) {
            foreach ($files as $file) {
                if (strpos($file[0], "http://")) {
                    $fcontent = file_get_contents($file[0]);
                    // TODO : revoir path
                    // $path = file_put_contents(SITE_DIR . "tmp/" . $file[1], $fcontent);
                } else {
                    $path = $file[0];
                }

                $message->attach(
                    Swift_Attachment::fromPath($path)->setFilename($file[1])
                );
            }
        }

        return $message;
    }
}
